objects, rpc: Code cleanup
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34
35 # Note: these are automake-specific variables, and must be named after
36 # the directory + 'dir' suffix
37 clientdir = $(pkgpythondir)/client
38 hypervisordir = $(pkgpythondir)/hypervisor
39 httpdir = $(pkgpythondir)/http
40 masterddir = $(pkgpythondir)/masterd
41 confddir = $(pkgpythondir)/confd
42 rapidir = $(pkgpythondir)/rapi
43 serverdir = $(pkgpythondir)/server
44 watcherdir = $(pkgpythondir)/watcher
45 impexpddir = $(pkgpythondir)/impexpd
46 utilsdir = $(pkgpythondir)/utils
47 toolsdir = $(pkglibdir)/tools
48 iallocatorsdir = $(pkglibdir)/iallocators
49 pytoolsdir = $(pkgpythondir)/tools
50 docdir = $(datadir)/doc/$(PACKAGE)
51 myexeclibdir = $(pkglibdir)
52
53 # Delete output file if an error occurred while building it
54 .DELETE_ON_ERROR:
55
56 HTOOLS_DIRS = \
57         htools \
58         htools/Ganeti \
59         htools/Ganeti/Confd \
60         htools/Ganeti/HTools \
61         htools/Ganeti/HTools/Program \
62         htools/Ganeti/Query \
63         htest \
64         htest/Test \
65         htest/Test/Ganeti \
66         htest/Test/Ganeti/Confd \
67         htest/Test/Ganeti/HTools \
68         htest/Test/Ganeti/Query
69
70 DIRS = \
71         autotools \
72         daemons \
73         devel \
74         doc \
75         doc/examples \
76         doc/examples/hooks \
77         doc/examples/gnt-debug \
78         $(HTOOLS_DIRS) \
79         lib \
80         lib/client \
81         lib/build \
82         lib/confd \
83         lib/http \
84         lib/hypervisor \
85         lib/impexpd \
86         lib/masterd \
87         lib/rapi \
88         lib/server \
89         lib/tools \
90         lib/utils \
91         lib/watcher \
92         man \
93         qa \
94         test \
95         test/data \
96         test/data/ovfdata \
97         test/data/ovfdata/other \
98         htest/data \
99         htest/data/rapi \
100         htest/shelltests \
101         tools
102
103 BUILDTIME_DIR_AUTOCREATE = \
104         scripts \
105         $(APIDOC_DIR) \
106         $(APIDOC_PY_DIR) \
107         $(APIDOC_HS_DIR) \
108         $(APIDOC_HS_DIR)/Ganeti \
109         $(APIDOC_HS_DIR)/Ganeti/Confd \
110         $(APIDOC_HS_DIR)/Ganeti/HTools \
111         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
112         $(APIDOC_HS_DIR)/Ganeti/Query \
113         $(COVERAGE_DIR) \
114         $(COVERAGE_PY_DIR) \
115         $(COVERAGE_HS_DIR) \
116         .hpc
117
118 BUILDTIME_DIRS = \
119         $(BUILDTIME_DIR_AUTOCREATE) \
120         doc/html
121
122 DIRCHECK_EXCLUDE = \
123         $(BUILDTIME_DIRS) \
124         ganeti-[0-9]*.[0-9]*.[0-9]* \
125         doc/html/_*
126
127 # some helper vars
128 COVERAGE_DIR = doc/coverage
129 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
130 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
131 APIDOC_DIR = doc/api
132 APIDOC_PY_DIR = $(APIDOC_DIR)/py
133 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
134
135 MAINTAINERCLEANFILES = \
136         $(docpng) \
137         $(maninput) \
138         doc/install-quick.rst \
139         doc/news.rst \
140         doc/upgrade.rst \
141         vcs-version
142
143 maintainer-clean-local:
144         rm -rf $(BUILDTIME_DIRS)
145
146 CLEANFILES = \
147         $(addsuffix /*.py[co],$(DIRS)) \
148         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
149         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
150         $(PYTHON_BOOTSTRAP) \
151         epydoc.conf \
152         $(REPLACE_VARS_SED) \
153         daemons/daemon-util \
154         daemons/ganeti-cleaner \
155         devel/upload \
156         $(BUILT_EXAMPLES) \
157         doc/examples/bash_completion \
158         lib/_generated_rpc.py \
159         $(man_MANS) \
160         $(manhtml) \
161         tools/kvm-ifup \
162         stamp-directories \
163         stamp-srclinks \
164         $(nodist_pkgpython_PYTHON) \
165         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
166         $(HS_BUILT_TEST_HELPERS) \
167         .hpc/*.mix htools/*.tix htest/*.tix \
168         doc/hs-lint.html
169
170 GENERATED_FILES = \
171         $(built_base_sources) \
172         $(BUILT_PYTHON_SOURCES) \
173         $(PYTHON_BOOTSTRAP)
174
175 built_base_sources = \
176         stamp-directories \
177         stamp-srclinks
178
179 built_python_base_sources = \
180         lib/_autoconf.py \
181         lib/_vcsversion.py
182
183 BUILT_PYTHON_SOURCES = \
184         $(built_python_base_sources) \
185         lib/_generated_rpc.py
186
187 # Generating the RPC wrappers depends on many things, so make sure
188 # it's built at the end of the built sources
189 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
190
191 # these are all built from the underlying %.in sources
192 BUILT_EXAMPLES = \
193         doc/examples/ganeti-kvm-poweroff.initd \
194         doc/examples/ganeti.cron \
195         doc/examples/ganeti.initd \
196         doc/examples/gnt-config-backup \
197         doc/examples/hooks/ipsec
198
199 nodist_pkgpython_PYTHON = \
200         $(BUILT_PYTHON_SOURCES)
201
202 noinst_PYTHON = \
203         lib/build/__init__.py \
204         lib/build/sphinx_ext.py \
205         lib/build/shell_example_lexer.py
206
207 pkgpython_PYTHON = \
208         lib/__init__.py \
209         lib/asyncnotifier.py \
210         lib/backend.py \
211         lib/bdev.py \
212         lib/bootstrap.py \
213         lib/cli.py \
214         lib/cmdlib.py \
215         lib/compat.py \
216         lib/config.py \
217         lib/constants.py \
218         lib/daemon.py \
219         lib/errors.py \
220         lib/ht.py \
221         lib/jqueue.py \
222         lib/jstore.py \
223         lib/locking.py \
224         lib/luxi.py \
225         lib/mcpu.py \
226         lib/netutils.py \
227         lib/objects.py \
228         lib/objectutils.py \
229         lib/opcodes.py \
230         lib/ovf.py \
231         lib/qlang.py \
232         lib/query.py \
233         lib/rpc.py \
234         lib/rpc_defs.py \
235         lib/runtime.py \
236         lib/serializer.py \
237         lib/ssconf.py \
238         lib/ssh.py \
239         lib/storage.py \
240         lib/uidpool.py \
241         lib/workerpool.py
242
243 client_PYTHON = \
244         lib/client/__init__.py \
245         lib/client/gnt_backup.py \
246         lib/client/gnt_cluster.py \
247         lib/client/gnt_debug.py \
248         lib/client/gnt_group.py \
249         lib/client/gnt_instance.py \
250         lib/client/gnt_job.py \
251         lib/client/gnt_node.py \
252         lib/client/gnt_os.py
253
254 hypervisor_PYTHON = \
255         lib/hypervisor/__init__.py \
256         lib/hypervisor/hv_base.py \
257         lib/hypervisor/hv_chroot.py \
258         lib/hypervisor/hv_fake.py \
259         lib/hypervisor/hv_kvm.py \
260         lib/hypervisor/hv_lxc.py \
261         lib/hypervisor/hv_xen.py
262
263 rapi_PYTHON = \
264         lib/rapi/__init__.py \
265         lib/rapi/baserlib.py \
266         lib/rapi/client.py \
267         lib/rapi/client_utils.py \
268         lib/rapi/connector.py \
269         lib/rapi/rlib2.py \
270         lib/rapi/testutils.py
271
272 http_PYTHON = \
273         lib/http/__init__.py \
274         lib/http/auth.py \
275         lib/http/client.py \
276         lib/http/server.py
277
278 confd_PYTHON = \
279         lib/confd/__init__.py \
280         lib/confd/client.py \
281         lib/confd/querylib.py \
282         lib/confd/server.py
283
284 masterd_PYTHON = \
285         lib/masterd/__init__.py \
286         lib/masterd/iallocator.py \
287         lib/masterd/instance.py
288
289 impexpd_PYTHON = \
290         lib/impexpd/__init__.py
291
292 watcher_PYTHON = \
293         lib/watcher/__init__.py \
294         lib/watcher/nodemaint.py \
295         lib/watcher/state.py
296
297 server_PYTHON = \
298         lib/server/__init__.py \
299         lib/server/confd.py \
300         lib/server/masterd.py \
301         lib/server/noded.py \
302         lib/server/rapi.py
303
304 pytools_PYTHON = \
305         lib/tools/__init__.py \
306         lib/tools/ensure_dirs.py
307
308 utils_PYTHON = \
309         lib/utils/__init__.py \
310         lib/utils/algo.py \
311         lib/utils/filelock.py \
312         lib/utils/hash.py \
313         lib/utils/io.py \
314         lib/utils/log.py \
315         lib/utils/mlock.py \
316         lib/utils/nodesetup.py \
317         lib/utils/process.py \
318         lib/utils/retry.py \
319         lib/utils/text.py \
320         lib/utils/wrapper.py \
321         lib/utils/x509.py
322
323 docrst = \
324         doc/admin.rst \
325         doc/design-2.0.rst \
326         doc/design-2.1.rst \
327         doc/design-2.2.rst \
328         doc/design-2.3.rst \
329         doc/design-htools-2.3.rst \
330         doc/design-2.4.rst \
331         doc/design-2.5.rst \
332         doc/design-draft.rst \
333         doc/design-oob.rst \
334         doc/design-cpu-pinning.rst \
335         doc/design-query2.rst \
336         doc/design-x509-ca.rst \
337         doc/design-http-server.rst \
338         doc/design-impexp2.rst \
339         doc/design-lu-generated-jobs.rst \
340         doc/design-multi-reloc.rst \
341         doc/design-network.rst \
342         doc/design-chained-jobs.rst \
343         doc/design-ovf-support.rst \
344         doc/design-autorepair.rst \
345         doc/design-resource-model.rst \
346         doc/cluster-merge.rst \
347         doc/design-shared-storage.rst \
348         doc/design-node-state-cache.rst \
349         doc/design-virtual-clusters.rst \
350         doc/design-bulk-create.rst \
351         doc/design-query-splitting.rst \
352         doc/devnotes.rst \
353         doc/glossary.rst \
354         doc/hooks.rst \
355         doc/iallocator.rst \
356         doc/index.rst \
357         doc/install-quick.rst \
358         doc/install.rst \
359         doc/locking.rst \
360         doc/move-instance.rst \
361         doc/news.rst \
362         doc/ovfconverter.rst \
363         doc/rapi.rst \
364         doc/security.rst \
365         doc/upgrade.rst \
366         doc/walkthrough.rst
367
368 HS_PROGS = htools/htools
369 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
370
371 HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
372 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
373 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
374
375 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
376 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
377 HEXTRA =
378 # internal extra flags (used for htest/test mainly)
379 HEXTRA_INT =
380 # exclude options for coverage reports
381 HPCEXCL = --exclude Main \
382         --exclude Ganeti.Constants \
383         --exclude Ganeti.THH \
384         --exclude Ganeti.HTools.QC \
385         --exclude Ganeti.Version \
386         --exclude Test.Ganeti.TestCommon \
387         --exclude Test.Ganeti.TestHTools \
388         --exclude Test.Ganeti.TestHelper \
389         --exclude Test.Ganeti.TestImports \
390         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
391
392 HS_LIB_SRCS = \
393         htools/Ganeti/HTools/CLI.hs \
394         htools/Ganeti/HTools/Cluster.hs \
395         htools/Ganeti/HTools/Container.hs \
396         htools/Ganeti/HTools/ExtLoader.hs \
397         htools/Ganeti/HTools/Group.hs \
398         htools/Ganeti/HTools/IAlloc.hs \
399         htools/Ganeti/HTools/Instance.hs \
400         htools/Ganeti/HTools/Loader.hs \
401         htools/Ganeti/HTools/Luxi.hs \
402         htools/Ganeti/HTools/Node.hs \
403         htools/Ganeti/HTools/PeerMap.hs \
404         htools/Ganeti/HTools/Rapi.hs \
405         htools/Ganeti/HTools/Simu.hs \
406         htools/Ganeti/HTools/Text.hs \
407         htools/Ganeti/HTools/Types.hs \
408         htools/Ganeti/HTools/Utils.hs \
409         htools/Ganeti/HTools/Program.hs \
410         htools/Ganeti/HTools/Program/Hail.hs \
411         htools/Ganeti/HTools/Program/Hbal.hs \
412         htools/Ganeti/HTools/Program/Hcheck.hs \
413         htools/Ganeti/HTools/Program/Hinfo.hs \
414         htools/Ganeti/HTools/Program/Hscan.hs \
415         htools/Ganeti/HTools/Program/Hspace.hs \
416         htools/Ganeti/BasicTypes.hs \
417         htools/Ganeti/Common.hs \
418         htools/Ganeti/Compat.hs \
419         htools/Ganeti/Confd.hs \
420         htools/Ganeti/Confd/Server.hs \
421         htools/Ganeti/Confd/Utils.hs \
422         htools/Ganeti/Config.hs \
423         htools/Ganeti/Daemon.hs \
424         htools/Ganeti/Hash.hs \
425         htools/Ganeti/Jobs.hs \
426         htools/Ganeti/JSON.hs \
427         htools/Ganeti/Logging.hs \
428         htools/Ganeti/Luxi.hs \
429         htools/Ganeti/Objects.hs \
430         htools/Ganeti/OpCodes.hs \
431         htools/Ganeti/Query/Common.hs \
432         htools/Ganeti/Query/Filter.hs \
433         htools/Ganeti/Query/Language.hs \
434         htools/Ganeti/Query/Node.hs \
435         htools/Ganeti/Query/Query.hs \
436         htools/Ganeti/Query/Server.hs \
437         htools/Ganeti/Query/Types.hs \
438         htools/Ganeti/Rpc.hs \
439         htools/Ganeti/Runtime.hs \
440         htools/Ganeti/Ssconf.hs \
441         htools/Ganeti/THH.hs
442
443 HS_TEST_SRCS = \
444         htest/Test/Ganeti/BasicTypes.hs \
445         htest/Test/Ganeti/Common.hs \
446         htest/Test/Ganeti/Daemon.hs \
447         htest/Test/Ganeti/Confd/Utils.hs \
448         htest/Test/Ganeti/HTools/CLI.hs \
449         htest/Test/Ganeti/HTools/Cluster.hs \
450         htest/Test/Ganeti/HTools/Container.hs \
451         htest/Test/Ganeti/HTools/Instance.hs \
452         htest/Test/Ganeti/HTools/Loader.hs \
453         htest/Test/Ganeti/HTools/Node.hs \
454         htest/Test/Ganeti/HTools/PeerMap.hs \
455         htest/Test/Ganeti/HTools/Simu.hs \
456         htest/Test/Ganeti/HTools/Text.hs \
457         htest/Test/Ganeti/HTools/Types.hs \
458         htest/Test/Ganeti/HTools/Utils.hs \
459         htest/Test/Ganeti/JSON.hs \
460         htest/Test/Ganeti/Jobs.hs \
461         htest/Test/Ganeti/Luxi.hs \
462         htest/Test/Ganeti/Objects.hs \
463         htest/Test/Ganeti/OpCodes.hs \
464         htest/Test/Ganeti/Query/Filter.hs \
465         htest/Test/Ganeti/Query/Language.hs \
466         htest/Test/Ganeti/Query/Query.hs \
467         htest/Test/Ganeti/Rpc.hs \
468         htest/Test/Ganeti/Ssconf.hs \
469         htest/Test/Ganeti/TestCommon.hs \
470         htest/Test/Ganeti/TestHTools.hs \
471         htest/Test/Ganeti/TestHelper.hs
472
473 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
474
475 HS_BUILT_SRCS = \
476         htest/Test/Ganeti/TestImports.hs \
477         htools/Ganeti/Constants.hs \
478         htools/Ganeti/Version.hs
479 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
480
481 $(RUN_IN_TEMPDIR): | stamp-directories
482
483 # Note: we use here an order-only prerequisite, as the contents of
484 # _autoconf.py are not actually influencing the html build output: it
485 # has to exist in order for the sphinx module to be loaded
486 # successfully, but we certainly don't want the docs to be rebuilt if
487 # it changes
488 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
489         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
490         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
491         | $(BUILT_PYTHON_SOURCES)
492         @test -n "$(SPHINX)" || \
493             { echo 'sphinx-build' not found during configure; exit 1; }
494         @mkdir_p@ $(dir $@)
495         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
496             -d . \
497             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
498             -D release="$(PACKAGE_VERSION)" \
499             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
500         rm -f doc/html/.buildinfo doc/html/objects.inv
501         touch $@
502
503 doc/html: doc/html/index.html
504
505 doc/install-quick.rst: INSTALL
506 doc/news.rst: NEWS
507 doc/upgrade.rst: UPGRADE
508
509 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
510         set -e; \
511         { echo '.. This file is automatically updated at build time from $<.'; \
512           echo '.. Do not edit.'; \
513           echo; \
514           cat $<; \
515         } > $@
516
517 docdot = \
518         doc/arch-2.0.dot \
519         doc/design-2.1-lock-acquire.dot \
520         doc/design-2.1-lock-release.dot
521
522 docpng = $(patsubst %.dot,%.png,$(docdot))
523
524 # Things to build but not to install (add it to EXTRA_DIST if it should be
525 # distributed)
526 noinst_DATA = \
527         devel/upload \
528         doc/html \
529         $(BUILT_EXAMPLES) \
530         doc/examples/bash_completion \
531         $(manhtml)
532
533 gnt_scripts = \
534         scripts/gnt-backup \
535         scripts/gnt-cluster \
536         scripts/gnt-debug \
537         scripts/gnt-group \
538         scripts/gnt-instance \
539         scripts/gnt-job \
540         scripts/gnt-node \
541         scripts/gnt-os
542
543 PYTHON_BOOTSTRAP_SBIN = \
544         daemons/ganeti-masterd \
545         daemons/ganeti-noded \
546         daemons/ganeti-watcher \
547         daemons/ganeti-rapi \
548         $(gnt_scripts)
549
550 if PY_CONFD
551 PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
552 endif
553
554 PYTHON_BOOTSTRAP = \
555         $(PYTHON_BOOTSTRAP_SBIN) \
556         tools/ensure-dirs
557
558 qa_scripts = \
559         qa/__init__.py \
560         qa/ganeti-qa.py \
561         qa/qa_cluster.py \
562         qa/qa_config.py \
563         qa/qa_daemon.py \
564         qa/qa_env.py \
565         qa/qa_error.py \
566         qa/qa_group.py \
567         qa/qa_instance.py \
568         qa/qa_job.py \
569         qa/qa_node.py \
570         qa/qa_os.py \
571         qa/qa_rapi.py \
572         qa/qa_tags.py \
573         qa/qa_utils.py
574
575 bin_SCRIPTS =
576 if WANT_HTOOLS
577 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
578 install-exec-hook:
579         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
580 # FIXME: this is a hardcoded logic, instead of auto-resolving
581         $(LN_S) -f ../../../bin/htools \
582                    $(DESTDIR)$(iallocatorsdir)/hail
583         for role in $(HS_BIN_ROLES); do \
584                 $(LN_S) -f htools \
585                            $(DESTDIR)$(bindir)/$$role ; \
586         done
587 if HS_CONFD
588         mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
589 endif
590 endif
591
592 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
593         @if [ -z "$(HTOOLS)" ]; then \
594           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
595           exit 1; \
596         fi
597         @if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
598           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
599           exit 1; \
600         fi
601         @rm -f $(notdir $@).tix
602         $(GHC) --make \
603           $(HFLAGS) \
604           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
605           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
606           $(HEXTRA) $(HEXTRA_INT) $@
607         @touch "$@"
608
609 # for the htest/test binary, we need to enable profiling/coverage
610 htest/test: HEXTRA_INT=-fhpc -ihtest
611
612 # we compile the hpc-htools binary with the program coverage
613 htest/hpc-htools: HEXTRA_INT=-fhpc
614
615 # test dependency
616 htest/offline-tests.sh: htest/hpc-htools
617
618 # rules for building profiling-enabled versions of the haskell
619 # programs: hs-prof does the full two-step build, whereas
620 # hs-prof-quick does only the final rebuild (hs-prof must have been
621 # run before)
622 .PHONY: hs-prof hs-prof-quick
623 hs-prof:
624         $(MAKE) $(AM_MAKEFLAGS) clean
625         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
626         rm -f $(HS_ALL_PROGS)
627         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
628
629 hs-prof-quick:
630         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
631
632 dist_sbin_SCRIPTS = \
633         tools/ganeti-listrunner
634
635 nodist_sbin_SCRIPTS = \
636         $(PYTHON_BOOTSTRAP_SBIN) \
637         daemons/ganeti-cleaner
638
639 if HS_CONFD
640 nodist_sbin_SCRIPTS += htools/hconfd
641 endif
642
643 python_scripts = \
644         tools/burnin \
645         tools/cfgshell \
646         tools/cfgupgrade \
647         tools/cfgupgrade12 \
648         tools/cluster-merge \
649         tools/confd-client \
650         tools/fmtjson \
651         tools/lvmstrap \
652         tools/move-instance \
653         tools/ovfconverter \
654         tools/setup-ssh \
655         tools/sanitize-config
656
657 dist_tools_SCRIPTS = \
658         $(python_scripts) \
659         tools/kvm-console-wrapper \
660         tools/xm-console-wrapper \
661         tools/master-ip-setup
662
663 pkglib_python_scripts = \
664         daemons/import-export \
665         tools/check-cert-expired
666
667 nodist_pkglib_python_scripts = \
668         tools/ensure-dirs
669
670 myexeclib_SCRIPTS = \
671         daemons/daemon-util \
672         tools/kvm-ifup \
673         $(pkglib_python_scripts)
674
675 nodist_myexeclib_SCRIPTS = \
676         $(nodist_pkglib_python_scripts)
677
678 EXTRA_DIST = \
679         NEWS \
680         UPGRADE \
681         epydoc.conf.in \
682         pylintrc \
683         autotools/build-bash-completion \
684         autotools/build-rpc \
685         autotools/check-header \
686         autotools/check-python-code \
687         autotools/check-imports \
688         autotools/check-man-dashes \
689         autotools/check-man-warnings \
690         autotools/check-news \
691         autotools/check-tar \
692         autotools/check-version \
693         autotools/convert-constants \
694         autotools/docpp \
695         autotools/gen-coverage \
696         autotools/testrunner \
697         autotools/wrong-hardcoded-paths \
698         $(RUN_IN_TEMPDIR) \
699         daemons/daemon-util.in \
700         daemons/ganeti-cleaner.in \
701         $(pkglib_python_scripts) \
702         devel/upload.in \
703         tools/kvm-ifup.in \
704         $(docdot) \
705         $(docpng) \
706         $(docrst) \
707         doc/conf.py \
708         doc/html \
709         $(BUILT_EXAMPLES:%=%.in) \
710         doc/examples/ganeti.default \
711         doc/examples/ganeti.default-debug \
712         doc/examples/hooks/ethers \
713         doc/examples/gnt-debug/README \
714         doc/examples/gnt-debug/delay0.json \
715         doc/examples/gnt-debug/delay50.json \
716         test/lockperf.py \
717         test/testutils.py \
718         test/mocks.py \
719         $(dist_TESTS) \
720         $(TEST_FILES) \
721         man/footer.rst \
722         $(manrst) \
723         $(maninput) \
724         qa/qa-sample.json \
725         $(qa_scripts) \
726         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
727         $(HS_PROG_SRCS) \
728         htools/lint-hints.hs \
729         htest/cli-tests-defs.sh \
730         htest/offline-test.sh
731
732 man_MANS = \
733         man/ganeti.7 \
734         man/ganeti-cleaner.8 \
735         man/ganeti-confd.8 \
736         man/ganeti-listrunner.8 \
737         man/ganeti-masterd.8 \
738         man/ganeti-noded.8 \
739         man/ganeti-os-interface.7 \
740         man/ganeti-rapi.8 \
741         man/ganeti-watcher.8 \
742         man/gnt-backup.8 \
743         man/gnt-cluster.8 \
744         man/gnt-debug.8 \
745         man/gnt-group.8 \
746         man/gnt-instance.8 \
747         man/gnt-job.8 \
748         man/gnt-node.8 \
749         man/gnt-os.8 \
750         man/hail.1 \
751         man/hbal.1 \
752         man/hcheck.1 \
753         man/hinfo.1 \
754         man/hscan.1 \
755         man/hspace.1 \
756         man/htools.1
757
758 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
759 manhtml = $(patsubst %.rst,%.html,$(manrst))
760 mangen = $(patsubst %.rst,%.gen,$(manrst))
761 maninput = \
762         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
763         $(patsubst %.html,%.html.in,$(manhtml)) \
764         man/footer.man man/footer.html $(mangen)
765
766 TEST_FILES = \
767         test/data/bdev-drbd-8.0.txt \
768         test/data/bdev-drbd-8.3.txt \
769         test/data/bdev-drbd-disk.txt \
770         test/data/bdev-drbd-net-ip4.txt \
771         test/data/bdev-drbd-net-ip6.txt \
772         test/data/cert1.pem \
773         test/data/ip-addr-show-dummy0.txt \
774         test/data/ip-addr-show-lo-ipv4.txt \
775         test/data/ip-addr-show-lo-ipv6.txt \
776         test/data/ip-addr-show-lo-oneline-ipv4.txt \
777         test/data/ip-addr-show-lo-oneline-ipv6.txt \
778         test/data/ip-addr-show-lo-oneline.txt \
779         test/data/ip-addr-show-lo.txt \
780         test/data/proc_drbd8.txt \
781         test/data/proc_drbd80-emptyline.txt \
782         test/data/proc_drbd83.txt \
783         test/data/proc_drbd83_sync.txt \
784         test/data/proc_drbd83_sync_krnl2.6.39.txt \
785         test/data/kvm_1.0_help.txt \
786         test/data/kvm_0.15.90_help.txt \
787         test/data/kvm_0.12.5_help.txt \
788         test/data/kvm_0.9.1_help.txt \
789         test/data/sys_drbd_usermode_helper.txt \
790         test/data/ovfdata/compr_disk.vmdk.gz \
791         test/data/ovfdata/config.ini \
792         test/data/ovfdata/corrupted_resources.ovf \
793         test/data/ovfdata/empty.ini \
794         test/data/ovfdata/empty.ovf \
795         test/data/ovfdata/ganeti.mf \
796         test/data/ovfdata/ganeti.ovf \
797         test/data/ovfdata/gzip_disk.ovf \
798         test/data/ovfdata/new_disk.vmdk \
799         test/data/ovfdata/no_disk.ini \
800         test/data/ovfdata/no_disk_in_ref.ovf \
801         test/data/ovfdata/no_os.ini \
802         test/data/ovfdata/no_ovf.ova \
803         test/data/ovfdata/ova.ova \
804         test/data/ovfdata/second_disk.vmdk \
805         test/data/ovfdata/rawdisk.raw \
806         test/data/ovfdata/unsafe_path.ini \
807         test/data/ovfdata/virtualbox.ovf \
808         test/data/ovfdata/wrong_extension.ovd \
809         test/data/ovfdata/wrong_config.ini \
810         test/data/ovfdata/wrong_manifest.mf \
811         test/data/ovfdata/wrong_manifest.ovf \
812         test/data/ovfdata/wrong_ova.ova \
813         test/data/ovfdata/wrong_xml.ovf \
814         test/data/ovfdata/other/rawdisk.raw \
815         test/data/vgreduce-removemissing-2.02.02.txt \
816         test/data/vgreduce-removemissing-2.02.66-fail.txt \
817         test/data/vgreduce-removemissing-2.02.66-ok.txt \
818         test/data/vgs-missing-pvs-2.02.02.txt \
819         test/data/vgs-missing-pvs-2.02.66.txt \
820         test/import-export_unittest-helper \
821         test/gnt-cli.test \
822         test/ganeti-cli.test \
823         htest/shelltests/htools-balancing.test \
824         htest/shelltests/htools-basic.test \
825         htest/shelltests/htools-dynutil.test \
826         htest/shelltests/htools-excl.test \
827         htest/shelltests/htools-hail.test \
828         htest/shelltests/htools-hspace.test \
829         htest/shelltests/htools-invalid.test \
830         htest/shelltests/htools-multi-group.test \
831         htest/shelltests/htools-no-backend.test \
832         htest/shelltests/htools-rapi.test \
833         htest/shelltests/htools-single-group.test \
834         htest/shelltests/htools-text-backend.test \
835         htest/data/hail-alloc-drbd.json \
836         htest/data/hail-change-group.json \
837         htest/data/hail-invalid-reloc.json \
838         htest/data/hail-node-evac.json \
839         htest/data/hail-reloc-drbd.json \
840         htest/data/hbal-split-insts.data \
841         htest/data/common-suffix.data \
842         htest/data/invalid-node.data \
843         htest/data/missing-resources.data \
844         htest/data/rapi/groups.json \
845         htest/data/rapi/info.json \
846         htest/data/rapi/instances.json \
847         htest/data/rapi/nodes.json
848
849 python_tests = \
850         doc/examples/rapi_testutils.py \
851         test/ganeti.asyncnotifier_unittest.py \
852         test/ganeti.backend_unittest.py \
853         test/ganeti.bdev_unittest.py \
854         test/ganeti.cli_unittest.py \
855         test/ganeti.client.gnt_cluster_unittest.py \
856         test/ganeti.client.gnt_instance_unittest.py \
857         test/ganeti.daemon_unittest.py \
858         test/ganeti.cmdlib_unittest.py \
859         test/ganeti.compat_unittest.py \
860         test/ganeti.confd.client_unittest.py \
861         test/ganeti.config_unittest.py \
862         test/ganeti.constants_unittest.py \
863         test/ganeti.errors_unittest.py \
864         test/ganeti.hooks_unittest.py \
865         test/ganeti.ht_unittest.py \
866         test/ganeti.http_unittest.py \
867         test/ganeti.hypervisor_unittest.py \
868         test/ganeti.hypervisor.hv_chroot_unittest.py \
869         test/ganeti.hypervisor.hv_fake_unittest.py \
870         test/ganeti.hypervisor.hv_kvm_unittest.py \
871         test/ganeti.hypervisor.hv_lxc_unittest.py \
872         test/ganeti.hypervisor.hv_xen_unittest.py \
873         test/ganeti.impexpd_unittest.py \
874         test/ganeti.jqueue_unittest.py \
875         test/ganeti.jstore_unittest.py \
876         test/ganeti.locking_unittest.py \
877         test/ganeti.luxi_unittest.py \
878         test/ganeti.masterd.instance_unittest.py \
879         test/ganeti.mcpu_unittest.py \
880         test/ganeti.netutils_unittest.py \
881         test/ganeti.objects_unittest.py \
882         test/ganeti.objectutils_unittest.py \
883         test/ganeti.opcodes_unittest.py \
884         test/ganeti.ovf_unittest.py \
885         test/ganeti.qlang_unittest.py \
886         test/ganeti.query_unittest.py \
887         test/ganeti.rapi.baserlib_unittest.py \
888         test/ganeti.rapi.client_unittest.py \
889         test/ganeti.rapi.resources_unittest.py \
890         test/ganeti.rapi.rlib2_unittest.py \
891         test/ganeti.rapi.testutils_unittest.py \
892         test/ganeti.rpc_unittest.py \
893         test/ganeti.runtime_unittest.py \
894         test/ganeti.serializer_unittest.py \
895         test/ganeti.ssh_unittest.py \
896         test/ganeti.storage_unittest.py \
897         test/ganeti.tools.ensure_dirs_unittest.py \
898         test/ganeti.uidpool_unittest.py \
899         test/ganeti.utils.algo_unittest.py \
900         test/ganeti.utils.filelock_unittest.py \
901         test/ganeti.utils.hash_unittest.py \
902         test/ganeti.utils.io_unittest.py \
903         test/ganeti.utils.log_unittest.py \
904         test/ganeti.utils.mlock_unittest.py \
905         test/ganeti.utils.nodesetup_unittest.py \
906         test/ganeti.utils.process_unittest.py \
907         test/ganeti.utils.retry_unittest.py \
908         test/ganeti.utils.text_unittest.py \
909         test/ganeti.utils.wrapper_unittest.py \
910         test/ganeti.utils.x509_unittest.py \
911         test/ganeti.utils_unittest.py \
912         test/ganeti.workerpool_unittest.py \
913         test/qa.qa_config_unittest.py \
914         test/cfgupgrade_unittest.py \
915         test/docs_unittest.py \
916         test/pycurl_reset_unittest.py \
917         test/tempfile_fork_unittest.py
918 if HAS_FAKEROOT
919 python_tests += test/ganeti.utils.io_unittest-runasroot.py
920 endif
921
922 haskell_tests = htest/test
923
924 dist_TESTS = \
925         test/check-cert-expired_unittest.bash \
926         test/daemon-util_unittest.bash \
927         test/ganeti-cleaner_unittest.bash \
928         test/import-export_unittest.bash \
929         test/cli-test.bash \
930         $(python_tests)
931
932 nodist_TESTS =
933 check_SCRIPTS =
934
935 if WANT_HTOOLSTESTS
936 nodist_TESTS += $(haskell_tests)
937 dist_TESTS += htest/offline-test.sh
938 check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
939 endif
940
941 TESTS = $(dist_TESTS) $(nodist_TESTS)
942
943 # Environment for all tests
944 PLAIN_TESTS_ENVIRONMENT = \
945         PYTHONPATH=. \
946         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
947         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
948         $(RUN_IN_TEMPDIR)
949
950 # Environment for tests run by automake
951 TESTS_ENVIRONMENT = \
952         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
953
954 all_python_code = \
955         $(dist_sbin_SCRIPTS) \
956         $(python_scripts) \
957         $(pkglib_python_scripts) \
958         $(nodist_pkglib_python_scripts) \
959         $(python_tests) \
960         $(pkgpython_PYTHON) \
961         $(client_PYTHON) \
962         $(hypervisor_PYTHON) \
963         $(rapi_PYTHON) \
964         $(server_PYTHON) \
965         $(pytools_PYTHON) \
966         $(http_PYTHON) \
967         $(confd_PYTHON) \
968         $(masterd_PYTHON) \
969         $(impexpd_PYTHON) \
970         $(utils_PYTHON) \
971         $(watcher_PYTHON) \
972         $(noinst_PYTHON) \
973         $(qa_scripts)
974
975 srclink_files = \
976         man/footer.rst \
977         test/check-cert-expired_unittest.bash \
978         test/daemon-util_unittest.bash \
979         test/ganeti-cleaner_unittest.bash \
980         test/import-export_unittest.bash \
981         test/cli-test.bash \
982         htest/offline-test.sh \
983         htest/cli-tests-defs.sh \
984         $(all_python_code) \
985         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
986
987 check_python_code = \
988         $(BUILD_BASH_COMPLETION) \
989         $(CHECK_IMPORTS) \
990         $(CHECK_HEADER) \
991         $(DOCPP) \
992         $(all_python_code)
993
994 lint_python_code = \
995         ganeti \
996         ganeti/http/server.py \
997         $(dist_sbin_SCRIPTS) \
998         $(python_scripts) \
999         $(pkglib_python_scripts) \
1000         $(BUILD_BASH_COMPLETION) \
1001         $(CHECK_IMPORTS) \
1002         $(CHECK_HEADER) \
1003         $(DOCPP) \
1004         $(PYTHON_BOOTSTRAP)
1005
1006 standalone_python_modules = \
1007         lib/rapi/client.py \
1008         tools/ganeti-listrunner
1009
1010 pep8_python_code = \
1011         ganeti \
1012         ganeti/http/server.py \
1013         $(dist_sbin_SCRIPTS) \
1014         $(python_scripts) \
1015         $(pkglib_python_scripts) \
1016         $(BUILD_BASH_COMPLETION) \
1017         $(CHECK_HEADER) \
1018         $(DOCPP) \
1019         $(PYTHON_BOOTSTRAP) \
1020         qa
1021
1022 test/daemon-util_unittest.bash: daemons/daemon-util
1023
1024 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1025
1026 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1027         sed -f $(REPLACE_VARS_SED) < $< > $@
1028         chmod +x $@
1029
1030 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1031         sed -f $(REPLACE_VARS_SED) < $< > $@
1032         chmod u+x $@
1033
1034 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1035         sed -f $(REPLACE_VARS_SED) < $< > $@
1036         chmod +x $@
1037
1038 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1039         sed -f $(REPLACE_VARS_SED) < $< > $@
1040
1041 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1042         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1043         $(GENERATED_FILES)
1044         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
1045
1046 doc/%.png: doc/%.dot
1047         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1048         $(DOT) -Tpng -o $@ $<
1049
1050 man/footer.man: man/footer.rst
1051         @test -n "$(PANDOC)" || \
1052           { echo 'pandoc' not found during configure; exit 1; }
1053         $(PANDOC) -f rst -t man -o $@ $<
1054
1055 man/footer.html: man/footer.rst
1056         @test -n "$(PANDOC)" || \
1057           { echo 'pandoc' not found during configure; exit 1; }
1058         $(PANDOC) -f rst -t html -o $@ $<
1059
1060 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1061         lib/build/shell_example_lexer.py \
1062         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1063         @echo "Checking $< for hardcoded paths..."
1064         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1065           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1066           exit 1; \
1067         fi
1068         set -e ; \
1069         trap 'echo auto-removing $@; rm $@' EXIT; \
1070         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1071         trap - EXIT
1072
1073 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1074         @test -n "$(PANDOC)" || \
1075           { echo 'pandoc' not found during configure; exit 1; }
1076         set -o pipefail ; \
1077         trap 'echo auto-removing $@; rm $@' EXIT; \
1078         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1079           sed -e 's/\\@/@/g' > $@; \
1080         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1081         $(CHECK_MAN_DASHES) $@; \
1082         trap - EXIT
1083
1084
1085 man/%.html.in: man/%.gen man/footer.html
1086         @test -n "$(PANDOC)" || \
1087           { echo 'pandoc' not found during configure; exit 1; }
1088         set -o pipefail ; \
1089         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1090           sed -e 's/\\@/@/g' > $@
1091
1092 man/%: man/%.in  $(REPLACE_VARS_SED)
1093         sed -f $(REPLACE_VARS_SED) < $< > $@
1094
1095 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1096         sed -f $(REPLACE_VARS_SED) < $< > $@
1097
1098 vcs-version:
1099         if test -d .git; then \
1100           git describe > $@; \
1101         elif test ! -f $@ ; then \
1102           echo "Cannot auto-generate $@ file"; exit 1; \
1103         fi
1104
1105 .PHONY: clean-vcs-version
1106 clean-vcs-version:
1107         rm -f vcs-version
1108
1109 .PHONY: regen-vcs-version
1110 regen-vcs-version:
1111         set -e; \
1112         cd $(srcdir); \
1113         if test -d .git; then \
1114           $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1115           $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1116         fi
1117
1118 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1119         vcs-version $(built_base_sources)
1120         set -e; \
1121         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1122         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1123
1124 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1125         lib/constants.py lib/_autoconf.py lib/luxi.py \
1126         $(CONVERT_CONSTANTS) $(built_base_sources) \
1127         | lib/_vcsversion.py
1128         set -e; \
1129         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1130
1131 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1132         $(built_base_sources)
1133         set -e; \
1134         { cat $< ; \
1135           echo ; \
1136           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1137             echo "import $$name ()" ; \
1138           done ; \
1139         } > $@
1140
1141 lib/_autoconf.py: Makefile | stamp-directories
1142         set -e; \
1143         { echo '# This file is automatically generated, do not edit!'; \
1144           echo '#'; \
1145           echo ''; \
1146           echo '"""Build-time configuration for Ganeti.'; \
1147           echo '';\
1148           echo 'This file is autogenerated by the build process.'; \
1149           echo 'For any changes you need to re-run ./configure (and'; \
1150           echo 'not edit by hand).'; \
1151           echo ''; \
1152           echo '"""'; \
1153           echo ''; \
1154           echo '# pylint: disable=C0301,C0324'; \
1155           echo '# because this is autogenerated, we do not want'; \
1156           echo '# style warnings' ; \
1157           echo ''; \
1158           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1159           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1160           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1161           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1162           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1163           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1164           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1165           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1166           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1167           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1168           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1169           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1170           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1171           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1172           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1173           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1174           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1175           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1176           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1177           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1178           echo "KVM_PATH = '$(KVM_PATH)'"; \
1179           echo "IP_PATH = '$(IP_PATH)'"; \
1180           echo "SOCAT_PATH = '$(SOCAT)'"; \
1181           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1182           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1183           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1184           echo "TOOLSDIR = '$(toolsdir)'"; \
1185           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1186           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1187           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1188           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1189           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1190           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1191           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1192           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1193           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1194           echo "RAPI_USER = '$(RAPI_USER)'"; \
1195           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1196           echo "CONFD_USER = '$(CONFD_USER)'"; \
1197           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1198           echo "NODED_USER = '$(NODED_USER)'"; \
1199           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1200           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1201           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1202           if [ "$(HTOOLS)" ]; then \
1203             echo "HTOOLS = True"; \
1204           else \
1205             echo "HTOOLS = False"; \
1206           fi; \
1207           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1208           echo "PY_CONFD = $(PY_CONFD)"; \
1209           echo "HS_CONFD = $(HS_CONFD)"; \
1210           echo "XEN_CMD = '$(XEN_CMD)'"; \
1211           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1212         } > $@
1213
1214 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1215         set -e; \
1216         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1217         { echo '# This file is automatically generated, do not edit!'; \
1218           echo '#'; \
1219           echo ''; \
1220           echo '"""Build-time VCS version number for Ganeti.'; \
1221           echo '';\
1222           echo 'This file is autogenerated by the build process.'; \
1223           echo 'For any changes you need to re-run ./configure (and'; \
1224           echo 'not edit by hand).'; \
1225           echo ''; \
1226           echo '"""'; \
1227           echo ''; \
1228           echo '# pylint: disable=C0301,C0324'; \
1229           echo '# because this is autogenerated, we do not want'; \
1230           echo '# style warnings' ; \
1231           echo ''; \
1232           echo "VCS_VERSION = '$$VCSVER'"; \
1233         } > $@
1234
1235 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1236         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1237
1238 $(REPLACE_VARS_SED): Makefile stamp-directories
1239         set -e; \
1240         { echo 's#@PREFIX@#$(prefix)#g'; \
1241           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1242           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1243           echo 's#@BINDIR@#$(bindir)#g'; \
1244           echo 's#@SBINDIR@#$(sbindir)#g'; \
1245           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1246           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1247           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1248           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1249           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1250           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1251           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1252           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1253           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1254           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1255           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1256           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1257           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1258           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1259           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1260           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1261           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1262           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1263           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1264           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1265           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1266         } > $@
1267
1268 # Using deferred evaluation
1269 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1270 daemons/ganeti-watcher: MODULE = ganeti.watcher
1271 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1272 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1273 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1274
1275 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1276         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1277         set -e; \
1278         { echo '#!/usr/bin/python'; \
1279           echo '# This file is automatically generated, do not edit!'; \
1280           echo "# Edit $(MODULE) instead."; \
1281           echo; \
1282           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1283           echo; \
1284           echo '# pylint: disable=C0103'; \
1285           echo '# C0103: Invalid name'; \
1286           echo; \
1287           echo 'import sys'; \
1288           echo 'import $(MODULE) as main'; \
1289           echo; \
1290           echo '# Temporarily alias commands until bash completion'; \
1291           echo '# generator is changed'; \
1292           echo 'if hasattr(main, "commands"):'; \
1293           echo '  commands = main.commands # pylint: disable=E1101'; \
1294           echo 'if hasattr(main, "aliases"):'; \
1295           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1296           echo; \
1297           echo 'if __name__ == "__main__":'; \
1298           echo '  sys.exit(main.Main())'; \
1299         } > $@
1300         chmod u+x $@
1301
1302 $(HS_BUILT_TEST_HELPERS): Makefile
1303         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1304         set -e; \
1305         { echo '#!/bin/sh'; \
1306           echo '# This file is automatically generated, do not edit!'; \
1307           echo "# Edit Makefile.am instead."; \
1308           echo; \
1309           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1310         } > $@
1311         chmod u+x $@
1312
1313 stamp-directories: Makefile
1314         $(MAKE) $(AM_MAKEFLAGS) ganeti
1315         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1316         touch $@
1317
1318 # We need to create symlinks because "make distcheck" will not install Python
1319 # files when building.
1320 stamp-srclinks: Makefile | stamp-directories
1321         set -e; \
1322         for i in $(srclink_files); do \
1323                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1324                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1325                 fi; \
1326         done
1327         touch $@
1328
1329 .PHONY: ganeti
1330 ganeti:
1331         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1332
1333 .PHONY: check-dirs
1334 check-dirs: $(GENERATED_FILES)
1335         @set -e; \
1336         find . -type d \( \( -name . \) -o \( \
1337                 -name .git -o \
1338                 -name autom4te.cache \
1339                 \) -prune -o -print \) | { \
1340                 error=; \
1341                 while read dir; do \
1342                         case "$$dir" in \
1343                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1344                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1345                         esac; \
1346                 done; \
1347                 for dir in $(DIRS); do \
1348                         if ! test -d "$$dir"; then \
1349                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1350                                 error=1; \
1351                         fi \
1352                 done; \
1353                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1354         }
1355
1356 .PHONY: check-local
1357 check-local: check-dirs $(GENERATED_FILES)
1358         $(CHECK_PYTHON_CODE) $(check_python_code)
1359         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1360         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1361         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1362         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1363         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1364         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1365                 echo "Incorrect version in README, expected $$expver"; \
1366                 exit 1; \
1367         fi; \
1368         for file in doc/iallocator.rst doc/hooks.rst; do \
1369                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1370                         "Documents Ganeti version $$expver"; then \
1371                         echo "Incorrect version in $$file, expected $$expver"; \
1372                         exit 1; \
1373                 fi; \
1374         done
1375
1376 .PHONY: hs-check
1377 hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1378         @rm -f test.tix
1379         ./htest/test
1380         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1381
1382 # E111: indentation is not a multiple of four
1383 # E121: continuation line indentation is not a multiple of four
1384 #       (since our indent level is not 4)
1385 # E125: continuation line does not distinguish itself from next logical line
1386 #       (since our indent level is not 4)
1387 # E127: continuation line over-indented for visual indent
1388 #       (since our indent level is not 4)
1389 # note: do NOT add E128 here; it's a valid style error in most cases!
1390 # I've seen real errors, but also some cases were we indent wrongly
1391 # due to line length; try to rework the cases where it is triggered,
1392 # instead of silencing it
1393 # E261: at least two spaces before inline comment
1394 # E501: line too long (80 characters)
1395 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1396
1397 # For excluding pep8 expects filenames only, not whole paths
1398 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1399
1400 LINT_TARGETS = pylint pylint-qa
1401 if HAS_PEP8
1402 LINT_TARGETS += pep8
1403 endif
1404 if HAS_HLINT
1405 LINT_TARGETS += hlint
1406 endif
1407
1408 .PHONY: lint
1409 lint: $(LINT_TARGETS)
1410
1411 .PHONY: pylint
1412 pylint: $(GENERATED_FILES)
1413         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1414         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1415
1416 .PHONY: pylint-qa
1417 pylint-qa: $(GENERATED_FILES)
1418         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1419         cd $(top_srcdir)/qa && \
1420           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1421           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1422
1423 .PHONY: pep8
1424 pep8: $(GENERATED_FILES)
1425         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1426         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1427                 --repeat $(pep8_python_code)
1428
1429 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1430 .PHONY: hlint
1431 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1432         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1433         if tty -s; then C="-c"; else C=""; fi; \
1434         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1435           --ignore "Use first" \
1436           --ignore "Use comparing" \
1437           --ignore "Use on" \
1438           --ignore "Reduce duplication" \
1439           --ignore "Use &&&" \
1440           --ignore "Use void" \
1441           --hint htools/lint-hints \
1442           $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1443
1444 # a dist hook rule for updating the vcs-version file; this is
1445 # hardcoded due to where it needs to build the file...
1446 dist-hook:
1447         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1448         rm -f $(top_distdir)/vcs-version
1449         cp -p $(srcdir)/vcs-version $(top_distdir)
1450
1451 # a distcheck hook rule for catching revision control directories
1452 distcheck-hook:
1453         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1454                 echo "Found revision control files in final archive." 1>&2; \
1455                 exit 1; \
1456         fi
1457         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1458                 echo "Found Python byte code in final archive." 1>&2; \
1459                 exit 1; \
1460         fi
1461         if find $(top_distdir) -name '*~' | grep .; then \
1462                 echo "Found backup files in final archive." 1>&2; \
1463                 exit 1; \
1464         fi
1465 # Empty files or directories should not be distributed. They can cause
1466 # unnecessary warnings for packagers. Directories used by automake during
1467 # distcheck must be excluded.
1468         if find $(top_distdir) -empty -and -not \( \
1469                         -path $(top_distdir)/_build -or \
1470                         -path $(top_distdir)/_inst \) | grep .; then \
1471                 echo "Found empty files or directories in final archive." 1>&2; \
1472                 exit 1; \
1473         fi
1474         if test -n "$(BUILD_RELEASE)" && \
1475            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1476                 echo "Found unreleased version in NEWS." >&2; \
1477                 exit 1; \
1478         fi
1479
1480 # When building a release, stricter checks should be used
1481 distcheck-release dist-release: export BUILD_RELEASE = 1
1482 distcheck-release: distcheck
1483
1484 distrebuildcheck: dist
1485         set -e; \
1486         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1487         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1488         cd $$builddir; \
1489         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1490         cd $(distdir); \
1491         ./configure; \
1492         $(MAKE) maintainer-clean; \
1493         cp $(abs_srcdir)/vcs-version .; \
1494         ./configure; \
1495         $(MAKE) $(AM_MAKEFLAGS)
1496
1497 dist-release: dist
1498         set -e; \
1499         for i in $(DIST_ARCHIVES); do \
1500                 echo -n "Checking $$i ... "; \
1501                 autotools/check-tar < $$i; \
1502                 echo OK; \
1503         done
1504
1505 install-exec-local:
1506         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1507           "$(DESTDIR)${localstatedir}/log/ganeti" \
1508           "$(DESTDIR)${localstatedir}/run/ganeti"
1509
1510 .PHONY: apidoc
1511 if WANT_HTOOLSAPIDOC
1512 apidoc: py-apidoc hs-apidoc
1513 else
1514 apidoc: py-apidoc
1515 endif
1516
1517 .PHONY: py-apidoc
1518 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1519         $(RUN_IN_TEMPDIR) epydoc -v \
1520                 --conf $(CURDIR)/epydoc.conf \
1521                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1522
1523 .PHONY: hs-apidoc
1524 hs-apidoc: $(HS_BUILT_SRCS)
1525         @test -n "$(HSCOLOUR)" || \
1526             { echo 'HsColour' not found during configure; exit 1; }
1527         @test -n "$(HADDOCK)" || \
1528             { echo 'haddock' not found during configure; exit 1; }
1529         rm -rf $(APIDOC_HS_DIR)/*
1530         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1531         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1532         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1533         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1534         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1535         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1536         set -e ; \
1537         cd htools; \
1538         if [ "$(HTOOLS_NOCURL)" ]; \
1539         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1540         else OPTGHC=""; \
1541         fi; \
1542         if [ "$(HTOOLS_PARALLEL3)" ]; \
1543         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1544         fi; \
1545         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1546         for file in $$RELSRCS; do \
1547                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1548                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1549         done ; \
1550         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1551                 -t ganeti-htools -p haddock-prologue \
1552                 --source-module="%{MODULE/.//}.html" \
1553                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1554                 $$OPTGHC \
1555                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1556
1557 .PHONY: TAGS
1558 TAGS: $(GENERATED_FILES)
1559         rm -f TAGS
1560         $(GHC) -e ":etags" -v0 $(HFLAGS) $(HS_LIBTEST_SRCS)
1561         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1562           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1563           -path './qa/*.py' | \
1564           etags -l python -a -
1565
1566 .PHONY: coverage
1567 if WANT_HTOOLS
1568 coverage: py-coverage hs-coverage
1569 else
1570 coverage: py-coverage
1571 endif
1572
1573 .PHONY: py-coverage
1574 py-coverage: $(GENERATED_FILES) $(python_tests)
1575         set -e; \
1576         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1577         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1578         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1579         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1580         $(python_tests)
1581
1582 .PHONY: hs-coverage
1583 hs-coverage: $(haskell_tests) htest/hpc-htools
1584         rm -f *.tix
1585         $(MAKE) $(AM_MAKEFLAGS) hs-check
1586         @mkdir_p@ $(COVERAGE_HS_DIR)
1587         hpc combine --union $(HPCEXCL) \
1588           test.tix hpc-htools.tix > coverage-htools.tix
1589         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1590         hpc report coverage-htools.tix
1591         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1592
1593 # Special "kind-of-QA" target for htools, needs special setup (all
1594 # tools compiled with -fhpc)
1595 .PHONY: live-test
1596 live-test: all
1597         set -e ; \
1598         cd htools; \
1599         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1600         rm -f *.tix *.mix; \
1601         ./live-test.sh; \
1602         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1603           --output=live-test.tix ; \
1604         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1605         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1606                 --srcdir=.. $(HPCEXCL) ; \
1607         hpc report --srcdir=.. live-test $(HPCEXCL)
1608
1609 commit-check: distcheck lint apidoc
1610
1611 .PHONY: gitignore-check
1612 gitignore-check:
1613         @if [ -n "`git status --short`" ]; then \
1614           echo "Git status is not clean!" 1>&2 ; \
1615           git status --short; \
1616           exit 1; \
1617         fi
1618
1619 # we don't need the ancient implicit rules:
1620 %: %,v
1621 %: RCS/%,v
1622 %: RCS/%
1623 %: s.%
1624 %: SCCS/s.%
1625
1626 -include ./Makefile.local
1627
1628 # vim: set noet :